indexing

   description: "Class that covers the pipe abstractions. A pipe is not %
   %available on every system (perhaps any system besides MSDOS :-), so%
   %you need to use the COMMON_OS class to attempt to create the correct %
   %pipe class for your system if you're on a non-POSIX system."

   author: "Berend de Boer"
   date: "$Date: Thu, 14 Sep 2000 17:06:24 +0200 $"
   revision: "$Revision: 1.3 $"

-- deferred 
class 

   BASE_PIPE

inherit

   STDC_BASE


feature -- the pipe
   
   read_descriptor: BASE_FILE_DESCRIPTOR

   write_descriptor: BASE_FILE_DESCRIPTOR


feature -- pipe operations
   
   close is
      do
         read_descriptor.close
         write_descriptor.close
      end


invariant
   
   valid_pipe: read_descriptor /= Void and write_descriptor /= Void

end -- class BASE_PIPE
