/*

Access to Posix extensions of signal.h header

*/

/*
defining this gives lots of compilation errors on Linux...

#define _POSIX_SOURCE 1
*/

#ifndef _P_SIGNAL_H_
#define _P_SIGNAL_H_


#include "eiffel.h"
#include <signal.h>


/* functions */

EIF_INTEGER posix_kill(EIF_INTEGER pid, EIF_INTEGER sig);
EIF_INTEGER posix_sigaction(int sig, EIF_POINTER act, EIF_POINTER oact);

/* constants */

EIF_INTEGER const_sa_nocldstop();

EIF_INTEGER const_sigalrm();
EIF_INTEGER const_sighup();
EIF_INTEGER const_sigkill();
EIF_INTEGER const_sigpipe();
EIF_INTEGER const_sigquit();
EIF_INTEGER const_sigchld();
EIF_INTEGER const_sigcont();
EIF_INTEGER const_sigstop();
EIF_INTEGER const_sigtstp();
EIF_INTEGER const_sigttin();
EIF_INTEGER const_sigttou();


/* struct sigaction */

EIF_INTEGER posix_sigaction_size();

EIF_POINTER posix_sa_handler(struct sigaction *act);
EIF_POINTER posix_sa_mask(struct sigaction *act);
EIF_INTEGER posix_sa_flags(struct sigaction *act);

void posix_set_sa_handler(struct sigaction *act, EIF_POINTER handler);
void posix_set_sa_flags(struct sigaction *act, EIF_INTEGER flags);


/* struct sigevent */

EIF_INTEGER posix_sigevent_size();

EIF_INTEGER posix_sigevent_sigev_notify(struct sigevent *p);
EIF_INTEGER posix_sigevent_sigev_signo(struct sigevent *p);

void posix_set_sigevent_sigev_notify(struct sigevent *p, EIF_INTEGER sigev_notify);
void posix_set_sigevent_sigev_signo(struct sigevent *p, EIF_INTEGER sigev_signo);


/* notify values */

EIF_INTEGER const_sigev_none();
EIF_INTEGER const_sigev_signal();
EIF_INTEGER const_sigev_thread();


#endif /* _P_SIGNAL_H_ */
