indexing

   description: "Class that covers Posix mmap.h."

   author: "Berend de Boer"
   date: "$Date: Sat, 07 Oct 2000 14:31:08 +0200 $"
   revision: "$Revision: 1.1 $"

class 

   PAPI_MMAN


feature {NONE} -- C binding
   
   posix_mmap(addr: POINTER; len, prot, flags, fildes, off: INTEGER): POINTER is
         -- Map a file descriptor into memory
      external "C"
      end
   
   posix_munmap(addr: POINTER; len: INTEGER): INTEGER is
         -- Unmap previously mapped addresses
      external "C"
      end
   
   
feature {NONE} -- private constants
   
   MAP_FAILED: POINTER is
         -- symbol MAP_FAILED
      external "C"
      alias "const_map_failed"
      end
   

feature {NONE} -- protection constants

   PROT_READ: INTEGER is
      external "C"
      alias "const_prot_read"
      end

   PROT_WRITE: INTEGER is
      external "C"
      alias "const_prot_write"
      end

   PROT_EXEC: INTEGER is
      external "C"
      alias "const_prot_exec"
      end

   PROT_NONE: INTEGER is
      external "C"
      alias "const_prot_none"
      end
   
   
feature {NONE} -- Sharing types

   MAP_SHARED: INTEGER is
         -- Changes are shared
      external "C"
      alias "const_map_shared"
      end

   MAP_PRIVATE: INTEGER is
         -- Changes are private
      external "C"
      alias "const_map_private"
      end

   MAP_FIXED: INTEGER is
      -- Interpret `addr' exactly
      external "C"
      alias "const_map_fixed"
      end
   
   
end -- class PAPI_MMAN
