indexing

   description: "Class that covers Posix shared memory routines."

   usage: "A shared memory object basically is a FILE_DESCRIPTOR."

   author: "Berend de Boer"
   date: "$Date: Sat, 05 Aug 2000 14:28:49 +0200 $"
   revision: "$Revision: 1.1 $"

class 

   POSIX_SHARED_MEMORY


inherit
   
   POSIX_FILE_DESCRIPTOR
      undefine
         make_as_duplicate,
         make_from_file,
         attach_to_fd,
         ttyname
      redefine
         do_open,
         do_create
      end
   
   
creation

   open_read,
   open_read_write,
   create_read_write  


feature {NONE} -- open/create
   
   do_open (a_path: STRING; flags: INTEGER) is
      local
         cpath: POINTER         
      do
         portable_path.make_expand (a_path)
         cpath := sh.string_to_pointer (portable_path)
         fd := posix_shm_open (cpath, flags, 0)
      end

   do_create (a_path: STRING; flags, mode: INTEGER) is
      local
         cpath: POINTER         
      do
         portable_path.make_expand (a_path)
         cpath := sh.string_to_pointer (portable_path)
         fd := posix_shm_open (cpath, flags, mode)
      end
   
   
feature {NONE} -- C binding
   
   posix_shm_open (a_name: POINTER; oflag, mode: INTEGER): INTEGER is
         -- Open a Shared Memory Object
      external "C"
      end


end -- class POSIX_SHARED_MEMORY
