indexing

	description: "Test POSIX semaphore classes."

  author: "Berend de Boer"
	date: "$Date: Sat, 05 Aug 2000 14:28:49 +0200 $"
	revision: "$Revision: 1.1 $"

class 

   TEST_P_SEMAPHORE


inherit

   POSIX_BASE
   
   
creation
   
   make
   
feature

   make is
      local
         unnamed,
         unnamed2: POSIX_UNNAMED_SEMAPHORE
         named: POSIX_NAMED_SEMAPHORE
         cmd_acquire: POSIX_TIMED_ACQUIRE
         signal: POSIX_SIGNAL
      do
         print ("Begin test semaphore.%N")         

         print ("Create an unnamed, unshared semaphore.%N")
         create unnamed.create_unshared (1)
         create unnamed2.create_unshared (4)
         
         print ("Its value: ")
         print (unnamed.value)
         print ("%N")

         print ("Lock the semaphore%N")
         unnamed.acquire

         print ("Its value: ")
         print (unnamed.value)
         print ("%N")

         print ("Unlock the semaphore%N")
         unnamed.release

         print ("Its value: ")
         print (unnamed.value)
         print ("%N")

         print ("Attemt lock the semaphore%N")
         unnamed.attempt_acquire
         unnamed.release

         print ("Destroy the semaphore%N")
         unnamed.destroy
         unnamed2.destroy

         print ("Create a named semaphore.%N")
         -- not supported by FreeBSD
         -- create named.create_exclusive ("berend", 0)

         print ("Some tests if SIGALRM generates an exception.%N")
         create signal.make (SIGNAL_ALARM)
         if signal.is_ignored then
            print ("Signal is ignored.%N")
         end
         if signal.is_defaulted then
            print ("Signal is defaulted.%N")
         end

         print ("Attempt to acquire a semaphore for 3 seconds.%N")
         print ("Doesn't work with SmallEiffel: it does not rescue the exception properly.%N")
         create unnamed.create_unshared (0)
         create cmd_acquire.make (3, unnamed)
         if cmd_acquire.execute then
            print ("!! acquire succeeded.%N")
         else
            print ("Acquire timed out.%N")
         end
         
         print ("End test system.%N")         
      end


end -- class TEST_P_SEMAPHORE
